package cn.estsh.i3plus.core.api.iservice.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.CoreDataSource;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2022/1/7 10:38
 * @Modify:
 **/
public interface ICoreDataSourceService {

        /**
         * 修改数据源对象
         *
         * @param dataObject
         * @return
         */
        @ApiOperation(value = "修改数据对象接口")
        CoreDataSource updateDataObject(CoreDataSource dataObject);

        /**
         * 保存数据源
         *
         * @param source
         * @return
         */
        @ApiOperation(value = "保存数据对象属性接口")
        CoreDataSource saveDataSource(CoreDataSource source);

        /**
         * 获取数据对象详细信息
         *
         * @param id 数据对象ID
         * @return 数据对象
         */
        @ApiOperation(value = "获取数据对象信息")
        CoreDataSource getCoreDatasourceObject(Long id);


        /**
         * 检查数据源唯一性
         *
         * @param source
         */
        @ApiOperation(value = "数据源唯一检查")
        void checkDataSourceOnly(CoreDataSource source);


        /**
         * 查询所有数据对象接口
         *
         * @param pager
         * @return
         */
        @ApiOperation(value = "查询所有数据对象接口")
        ListPager<CoreDataSource> queryDataObjectByPager(CoreDataSource coreDataSource, Pager pager);

        /**
         * 获取所有数据源对象
         *
         * @return
         */
        @ApiOperation(value = "获取所有数据源对象")
        List<CoreDataSource> listAll();

        /**
         * 删除数据源
         * @param id
         */
        void delete(Long id);

        /**
         * 获取所有可用datasource的code和id
         * @return
         */
        List<CoreDataSource> list();

        /**
         * 加载数据源
         */
        void initCoreDataSource();
    }
