package cn.estsh.i3plus.core.api.iservice.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.DataSeparatorMessage;
import cn.estsh.i3plus.pojo.platform.bean.DataSeparatorRule;

/**
 * @Description :通用数据分离
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2021/12/3 13:41
 * @Modify:
 **/
public interface IDataSeparatorService {

    /**
     * 进行数据分离
     * @param msg
     */
    void doSeparate(DataSeparatorMessage msg);

    /**
     * 添加分离规则
     * @param msg
     * @return
     */
    boolean addRule (DataSeparatorRule msg);

    /**
     * 需要删除redis中缓存
     * @param id
     * @return
     */
    boolean deleteRule(Long  id);

    /**
     * 更新数据库及redis
     * @param msg
     * @return
     */
    boolean update(DataSeparatorRule msg);

    /**
     * 根据
     * @param dataSeparatorRule
     * @param pager
     * @return
     */
    ListPager<DataSeparatorRule> query(DataSeparatorRule dataSeparatorRule, Pager pager);

    /**
     * 初始化数据到redis中
     */
    void separatorRedisInit();
}
