package cn.estsh.i3plus.core.api.iservice.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.model.platform.LogFieldModel;
import cn.estsh.i3plus.pojo.model.platform.SysLogModel;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogConsole;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogException;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogSystem;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogTaskTime;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-2-13 下午3:43
 * @Modify:
 **/
public interface ISysLogService {

    ListPager<SysLogException> queryLogExceptionPager(SysLogException log, Pager pager);
    List<SysLogException> findLogExceptionList(SysLogException log, Pager pager);
    List<SysLogException> findLogExceptionList(SysLogException log);
    SysLogException insertLogException(SysLogException log);
    SysLogException getLogException(SysLogException log);
    void deleteLogException(SysLogException log);

    ListPager<SysLogOperate> queryLogOperatePager(SysLogOperate log, Pager pager);
    List<SysLogOperate> findLogOperateList(SysLogOperate log, Pager pager);
    List<SysLogOperate> findLogOperateList(SysLogOperate log);
    SysLogOperate insertLogOperate(SysLogOperate log);
    SysLogOperate getLogOperate(SysLogOperate log);
    void deleteLogOperate(SysLogOperate log);

    ListPager<SysLogSystem> queryLogSystemPager(SysLogSystem log, Pager pager);
    List<SysLogSystem> findLogSystemList(SysLogSystem log, Pager pager);
    List<SysLogSystem> findLogSystemList(SysLogSystem log);
    SysLogSystem insertLogSystem(SysLogSystem log);
    SysLogSystem getLogSystem(SysLogSystem log);
    void deleteLogSystem(SysLogSystem log);

    ListPager<SysLogTaskTime> queryLogTaskTimePager(SysLogTaskTime log, Pager pager);
    List<SysLogTaskTime> findLogTaskTimeList(SysLogTaskTime log, Pager pager);
    List<SysLogTaskTime> findLogTaskTimeList(SysLogTaskTime log);
    SysLogTaskTime insertLogTaskTime(SysLogTaskTime log);
    SysLogTaskTime getLogTaskTime(SysLogTaskTime log);
    void deleteLogTaskTime(SysLogTaskTime log);

    ListPager<SysLogConsole> queryLogConsolePager(SysLogConsole log, Pager pager);
    List<SysLogConsole> findLogConsoleList(SysLogConsole log, Pager pager);
    List<SysLogConsole> findLogConsoleList(SysLogConsole log);
    SysLogConsole insertLogConsoleTime(SysLogConsole log);
    SysLogConsole getLogConsoleTime(SysLogConsole log);
    void deleteLogConsoleTime(SysLogConsole log);

    void actionCleanLog(String startTime, String endTime);

    @ApiOperation(value = "查询时间段内平均请求耗时",notes = "查询时间段内平均请求耗时")
    Map<String, Object> querySysLogSystemAvgExecuteTime(String startTime, String endTime);

    @ApiOperation(value = "查询时间段内各等级日志数量",notes = "查询时间段内各等级日志数量")
    Map<String, Object> querySysLogSystemByLevel(String startTime, String endTime);


    List<LogFieldModel> querySysLog(SysLogModel logModel,Pager pager);
}
