package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysPosition;
import cn.estsh.impp.framework.base.service.ICrudService;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 岗位服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-19 16:36
 * @Modify :
 **/
public interface ISysPositionService extends ICrudService<SysPosition> {

//    /**
//     * 修改数据
//     * @param position
//     */
//    @ApiOperation(value = "更新岗位信息")
//    void updateSysPosition(SysPosition position);
//
//    /**
//     * 根据Key 删除数据
//     * @param id
//     */
//    @ApiOperation(value = "删除岗位信息",notes = "根据ID 删除岗位信息")
//    void deleteSysPositionById(Long id);
//
//    /**
//     * 根据id批量删除岗位
//     * @param ids id数组
//     * @return
//     */
//    @ApiOperation(value = "删除岗位信息",notes = "根据ID 批量删除岗位信息")
//    void deleteSysPositionByIds(Long[] ids);
//
//    /**
//     * 新增数据
//     * @param position
//     * @return
//     */
//    @ApiOperation(value = "新增岗位信息")
//    SysPosition insertSysPosition(SysPosition position);
//
//    /**
//     * 查询所有数据
//     * @return
//     */
//    @ApiOperation(value = "查询所有岗位信息")
//    List<SysPosition> findSysPositionAll();
//
//    @ApiOperation(value = "查询岗位信息",notes = "根据岗位编码查询岗位信息")
//    List<SysPosition> findSysPositionByOrganizeCode(String organizeCode);
//
//    @ApiOperation(value = "根据组织代码获取岗位列表")
//    List<SysPosition> findSysPositionList(SysPosition position);
//
//    /**
//     * 复杂查询
//     *      不建议使用，　没有数据权限
//     * @param position
//     * @param pager
//     * @return
//     */
//    @Deprecated
//    @ApiOperation(value = "查询岗位信息",notes = "查询岗位信息 (分页，组合)")
//    ListPager<SysPosition> querySysPosition(SysPosition position, Pager pager);

    @ApiOperation(value = "岗位检查",notes = "岗位检查唯一(岗位代码)")
    void checkSysPositionOnly(SysPosition position);

    @ApiOperation(value = "查询岗位信息",notes = "查询岗位信息 (分页，组合)")
    ListPager<SysPosition> querySysPosition(SysPosition position,List<Long> idList, Pager pager);

//    /**
//     * 根据Key 数据
//     *
//     * @param id
//     * @return
//     */
//    @ApiOperation(value = "查询岗位信息",notes = "根据 ID 查询岗位信息")
//    SysPosition getSysPositionById(Long id);
//
//    /**
//     * 根据岗位信息进行查找
//     * @param position
//     * @param pager
//     * @return
//     */
//    @ApiOperation(value = "查询岗位信息",notes = "查询岗位信息 (分页，组合)")
//    ListPager findSysPositionByPager(SysPosition position, Pager pager);

    /**
     * 根据组织代码和岗位代码获取岗位信息
     * @param positionCode
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "查询岗位信息", notes = "根据组织代码和岗位代码获取岗位信息")
    SysPosition findPositionByPositionCodeAndOrganizeId(String positionCode,String  organizeCode);

    /**
     * 查询默认条件条件的岗位信息
     * @return
     */
    @ApiOperation(value = "查询默认条件条件的岗位信息", notes = "查询默认条件条件的岗位信息")
    List<SysPosition> findAllByBaseBean();

    /**
     * 根据岗位名称查询岗位信息
     * @param positionName
     * @return
     */
    @ApiOperation(value = "根据岗位名称查询岗位信息", notes = "根据岗位名称查询岗位信息")
    List<SysPosition> findAllByPositionName(String positionName);
}
