package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SysRefUserExternal;
import cn.estsh.impp.framework.base.service.ICrudService;

import java.util.List;

/**
 * @Description : 用户外部关联关系
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-09-03 13:45
 * @Modify:
 **/
public interface ISysRefUserExternalService extends ICrudService<SysRefUserExternal> {

    /**
     * 根据外部值和关联关系查询用户id
     * @param externalRef 外部关联关系
     * @param valueList 值集合
     * @return 用户id
     */
    List<Long> findUserByExternalRefAndValue(Integer externalRef, List<String> valueList);

    /**
     * 根据外部关系和用户id查询外部关联值
     * @param externalRef 关系
     * @param userIdList 用户id列表
     * @return 外部关联值
     */
    List<String> findExternalValueByRefAndUserId(Integer externalRef, List<Long> userIdList);

    SysRefUserExternal getSysRefUserExternalByRefAndValue(Integer externalRef, String value);

    SysRefUserExternal getSysRefUserExternalByRefAndUserId(Integer externalRef, Long userId);

}
