package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SysSmsTemplate;
import cn.estsh.impp.framework.base.service.ICrudService;

import java.util.List;

/**
 * @Description : 短信模板
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-12-14 20:14
 * @Modify:
 **/
public interface ISysSmsTemplateService extends ICrudService<SysSmsTemplate> {

    /**
     * 检查短信模板是否唯一
     *
     * @param smsTemplate 待检查的短信模板数据
     * @return 检查结果
     */
    boolean checkSysSmsTemplateOnly(SysSmsTemplate smsTemplate);

    /**
     * 根据code短信模板
     *
     * @param code 模板代码
     * @return 查询结果
     */
    SysSmsTemplate getSysSmsTemplateByCode(String code);

    /**
     * 根据模板状态查询模板信息
     *
     * @param status 模板状态
     * @return 查询结果
     */
    List<SysSmsTemplate> findSysSmsTemplateByStatus(Integer status);
}
