package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysTableTemplate;

import java.util.List;

/**
 * @author ns
 * @create 2022/3/17 0017 上午 10:52
 */
public interface ISysTableTemplateService {

    /**
     * 根据条件分页查询
     * @param sysTableTemplate
     * @param pager
     * @return
     */
    ListPager<SysTableTemplate> findSysTableTemplateByPage(SysTableTemplate sysTableTemplate, Pager pager);

    /**
     * 根据条件查询
     * @param sysTableTemplate
     * @return
     */
    List<SysTableTemplate> findSysTableTemplate(SysTableTemplate sysTableTemplate);

    /**
     * 根据id查询
     * @param sysTableTemplateId
     * @return
     */
    SysTableTemplate getSysTableTemplateById(Long sysTableTemplateId);

    /**
     * 更新table模板,如果不存在,则新增对应的模板
     * @param sysTableTemplate
     * @return
     */
    Boolean saveSysTableTemplate(SysTableTemplate sysTableTemplate);

    /**
     * 插入table模板
     * @param sysTableTemplate
     * @return
     */
    SysTableTemplate insertSysTableTemplate(SysTableTemplate sysTableTemplate);

    /**
     *  更新table模板
     * @param sysTableTemplate
     * @return
     */
    Boolean updateSysTableTemplate(SysTableTemplate sysTableTemplate);

    /**
     * 判断模板是否存在
     * @param sysTableTemplate
     * @return
     */
    Boolean isExistSysTableTemplate(SysTableTemplate sysTableTemplate);


    /**
     * 判断模板是否存在
     * @param id
     * @return
     */
    Boolean isExistSysTableTemplateById(Long id);


    /**
     * 判断模板是否存在
     * @param ids
     * @return
     */
    int deleteSysTableTemplateByIds(Long[] ids);
}
