package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SysUserPassword;
import cn.estsh.impp.framework.base.service.ICrudService;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-6-4 下午3:47
 * @Modify:
 **/
public interface ISysUserPasswordService extends ICrudService<SysUserPassword> {

    /**
     * 修改用户密码
     *
     * @param userId   用户ID
     * @param password 旧密码
     * @param newPwd   新密码
     */
    @ApiOperation(value = "修改用户密码")
    void updatePassword(Long userId, String password, String newPwd);

    @ApiOperation(value = "修改用户密码")
    void updatePassword(String loginName, String password, String newPwd);

    @ApiOperation(value = "重置用户密码")
    void updatePassword(Long userId, String password);

    @ApiOperation(value = "重置用户密码")
    void updatePasswordResetLastModifyTime(Long userId, String password,Boolean isCheckPassword);

    void updatePasswordWizoutSession(String loginName, String password, String newPwd);

    @ApiOperation(value = "根据密码反查")
     public List<SysUserPassword> findPasswordByPassword(String password,Long userId);

    @ApiOperation(value = "根据密码反查重置时间后的")
    public List<SysUserPassword> findPasswordByPasswordAndResetPwdTime(String password,Long userId);

    /**
     * 修改密码，根据密码id,和新密码
     * @param pwdId
     * @param newPwd
     */
    @ApiOperation(value = "供应商忘记密码")
    void updatePasswordByPwdIdAndNewPwd(Long pwdId,String newPwd);
}
