package cn.estsh.i3plus.core.apiservice.configuration;

import cn.estsh.i3plus.core.api.iservice.base.ISystemInitService;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.impp.framework.boot.init.IAppStartSystemInit;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-11 9:55
 * @Modify:
 **/
@Component
public class AppStartSystemInit implements IAppStartSystemInit {

    public static final Logger LOGGER = LoggerFactory.getLogger(CommonConstWords.SYSTEM_LOG);

    @Autowired
    private ISystemInitService systemInitService;

    /**
     * 系统初始化回调方法
     */
    @Override
    public void systemInit() {
        try {
            LOGGER.info("【IMPP-Core开始加载基础信息...】");
            systemInitService.putAndLoadAll();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
