package cn.estsh.i3plus.core.apiservice.configuration;

import cn.estsh.i3plus.core.apiservice.filter.CookieFrameFilter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.ArrayList;
import java.util.List;

@Configuration
public class FilterConfig {

    @Autowired
    private CookieFrameFilter cookieFrameFilter;

    @Bean
    public FilterRegistrationBean requestFilterRegistration() {
        FilterRegistrationBean registration = new FilterRegistrationBean();
        registration.setFilter(cookieFrameFilter);
        registration.setName("cookieFrameFilter");
        registration.setOrder(1);
        List<String> urlPatterns = new ArrayList<>();
        urlPatterns.add("/*");
        registration.setUrlPatterns(urlPatterns);
        return registration;
    }
}
