package cn.estsh.i3plus.core.apiservice.configuration;

import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.jpa.factory.BaseRepositoryFactoryBean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;

/**
 * @Description : 需要扫描其他包的配置文件
 *                  此类专门添加需要单独加载的其他模块的包
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-12 20:49
 * @Modify:
 **/
@Configuration
//扫描需要单独处理的包
@EnableFeignClients(basePackages = {//微服方法路径（需要在组件扫面中添加熔断类路径）
         "${impp.icloud.ext-packages:}.**"
})
@ComponentScan(basePackages = {
        //微服熔断路径 扫描qms iCloud熔断路径
        "${impp.icloud.ext.fallback-packages:}.**"
})
public class ScanPackageConfiguration {
    public static final Logger LOGGER = LoggerFactory.getLogger(CommonConstWords.SYSTEM_LOG);

    public ScanPackageConfiguration(){
        LOGGER.info("【扫描关联包...】");
    }
}
