package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysLogUserLoginService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.platform.bean.SysLogUserLogin;
import cn.estsh.i3plus.pojo.platform.repository.SysLogUserLoginRepository;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 用户登录日志
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-08-31 11:51
 * @Modify:
 **/
@Service
public class SysLogUserLoginService implements ISysLogUserLoginService {

    @Autowired
    private SysLogUserLoginRepository sysLogUserLoginRDao;

    /**
     * 用户登录日志分页查询
     *
     * @param sysLogUserLogin 查询条件
     * @param pager           分页信息
     * @return 查询结果
     */
    @Override
    public ListPager<SysLogUserLogin> querySysLogUserLoginByPager(SysLogUserLogin sysLogUserLogin, Pager pager) {
        DdlPackBean ddlPackBean = CoreHqlPack.packHqlQuerySysLogUserLogin(sysLogUserLogin);
        int count = sysLogUserLoginRDao.findByHqlWhereCount(ddlPackBean);
        pager = PagerHelper.getPager(pager, count);
        return new ListPager<>(sysLogUserLoginRDao.findByHqlWherePage(ddlPackBean, pager), pager);
    }

    /**
     * 用户登录日志查询
     *
     * @param sysLogUserLogin 查询条件
     * @return 查询结果
     */
    @Override
    public List<SysLogUserLogin> findSysUserLoginList(SysLogUserLogin sysLogUserLogin) {
        DdlPackBean ddlPackBean = CoreHqlPack.packHqlQuerySysLogUserLogin(sysLogUserLogin);
        return sysLogUserLoginRDao.findByHqlWhere(ddlPackBean);
    }
}
