package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysPojoVersionDetailService;
import cn.estsh.i3plus.core.api.iservice.busi.ISysPojoVersionService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.jpa.dao.BaseRepository;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.platform.bean.SysPojoVersion;
import cn.estsh.i3plus.pojo.platform.bean.SysPojoVersionPlan;
import cn.estsh.i3plus.pojo.platform.repository.SysPojoVersionPlanRepository;
import cn.estsh.i3plus.pojo.platform.repository.SysPojoVersionRepository;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import cn.estsh.impp.framework.base.service.CrudService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;
import java.util.Optional;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-4-21 下午2:28
 * @Modify:
 **/
@Service
public class SysPojoVersionService extends CrudService<SysPojoVersion> implements ISysPojoVersionService {

    @Autowired
    private SysPojoVersionPlanRepository pojoVersionPlanRepository;

    @Autowired
    private SysPojoVersionRepository pojoVersionRDao;

    @Autowired
    private ISysPojoVersionDetailService pojoVersionDetailService;

    @Override
    public BaseRepository<SysPojoVersion, Long> getRepository() {
        return pojoVersionRDao;
    }


    @Override
    public SysPojoVersion getPojoVersion(SysPojoVersion bean) {
        return pojoVersionRDao.getByProperty(DdlPackBean.getDdlPackBean(bean));
    }

    @Override
    public List<SysPojoVersion> findPojoVersionByUserBetweenTime(String userName, String startDate, String endDate) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean();
        DdlPreparedPack.getStringEqualPack(userName, "modifyUser", packBean);
        DdlPreparedPack.timeBuilder(startDate, endDate, "modifyDatetime", true, false, packBean);
        List<SysPojoVersion> pojoVersions = pojoVersionRDao.findByHqlWhere(packBean);

        DdlPackBean planPackBean = DdlPackBean.getDdlPackBean();
        List<SysPojoVersionPlan> pojoVersionPlans = pojoVersionPlanRepository.findByHqlWhere(planPackBean);

        pojoVersions.stream().parallel().forEach(d -> {
            Optional<SysPojoVersionPlan> plan = pojoVersionPlans.stream().filter(p -> d.getPlanId().equals(p.getId())).findFirst();
            plan.ifPresent(c -> d.setPojoClassTitle(c.getRefClassTitle()));
        });

        return pojoVersions;
    }

    @Override
    public SysPojoVersion packGetBean(SysPojoVersion bean) {
        if (Objects.nonNull(bean)) {
            bean.setVersionDetail(pojoVersionDetailService.get(bean.getPojoDetailId()));
        }
        return bean;
    }

    @Override
    public DdlPackBean getFindPagerPackBean(SysPojoVersion bean) {
        return CoreHqlPack.packHqlSysPojoVersion(bean);
    }
}
