package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysRefUserExternalService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.platform.bean.SysRefUserExternal;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import cn.estsh.impp.framework.base.service.CrudService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 用户外部关系
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-09-03 13:46
 * @Modify:
 **/
@Service
public class SysRefUserExternalService extends CrudService<SysRefUserExternal> implements ISysRefUserExternalService {

    public List<Long> findUserByExternalRefAndValue(Integer externalRef, List<String> valueList) {
        List<Long> userIdList = new ArrayList<>();

        DdlPackBean ddlPackBean = CoreHqlPack.packHqlFindUserIdByExternalRef(externalRef, valueList);
        List<SysRefUserExternal> sysRefUserExternalList = getRepository().findByHqlWhere(ddlPackBean);
        if (CollectionUtils.isNotEmpty(sysRefUserExternalList)) {
            sysRefUserExternalList.forEach(item -> userIdList.add(item.getUserId()));
        }

        return userIdList;
    }

    public List<String> findExternalValueByRefAndUserId(Integer externalRef, List<Long> userIdList) {
        List<String> refValList = new ArrayList<>();

        DdlPackBean ddlPackBean = CoreHqlPack.packHqlFindExternalRefByUserId(externalRef, userIdList);
        List<SysRefUserExternal> sysRefUserExternalList = getRepository().findByHqlWhere(ddlPackBean);
        if (CollectionUtils.isNotEmpty(sysRefUserExternalList)) {
            sysRefUserExternalList.forEach(item -> refValList.add(item.getRefValue()));
        }

        return refValList;
    }

    @Override
    public SysRefUserExternal getSysRefUserExternalByRefAndValue(Integer externalRef, String value) {
        SysRefUserExternal sysRefUserExternal = new SysRefUserExternal();
        sysRefUserExternal.setExternalRef(externalRef);
        sysRefUserExternal.setRefValue(value);
        return getRepository().getByProperty(CoreHqlPack.packHqlGetSysRefUserExternal(sysRefUserExternal));
    }

    @Override
    public SysRefUserExternal getSysRefUserExternalByRefAndUserId(Integer externalRef, Long userId) {
        SysRefUserExternal sysRefUserExternal = new SysRefUserExternal();
        sysRefUserExternal.setExternalRef(externalRef);
        sysRefUserExternal.setUserId(userId);
        return getRepository().getByProperty(CoreHqlPack.packHqlGetSysRefUserExternal(sysRefUserExternal));
    }


}
