package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysSmsSignService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysSmsSign;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import cn.estsh.impp.framework.base.service.CrudService;
import org.springframework.stereotype.Service;

/**
 * @Description : 短信签名
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-12-14 20:19
 * @Modify:
 **/
@Service
public class SysSmsSignService extends CrudService<SysSmsSign> implements ISysSmsSignService {


    @Override
    public DdlPackBean getFindPagerPackBean(SysSmsSign bean) {
        return CoreHqlPack.packHqlFindSysSmsSign(bean);
    }

    /**
     * 检查签名是否唯一
     *
     * @param sysSmsSign 签名信息
     * @return 检查结果
     */
    @Override
    public boolean checkSysSignOnly(SysSmsSign sysSmsSign) {
        return !baseRepository.isExitByHql(CoreHqlPack.packHqlCheckSysSmsSignOnly(sysSmsSign));
    }

    /**
     * 根据代码查询短信签名
     *
     * @param code 签名代码
     * @return 查询结果
     */
    @Override
    public SysSmsSign getSysSmsSignByCode(String code) {
        return baseRepository.getByProperty(
                new String[]{"isValid", "isDeleted", "signCode"},
                new Object[]{
                        CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue(),
                        CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                        code
                }
        );
    }
}
