package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysTableTemplateService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.platform.bean.SysTableTemplate;
import cn.estsh.i3plus.pojo.platform.repository.SysTableTemplateRepository;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author ns
 * @create 2022/3/17 0017 上午 11:09
 */
@Service
public class SysTableTemplateService implements ISysTableTemplateService {

    private SysTableTemplateRepository sysTableTemplateRepository;

    public SysTableTemplateService(SysTableTemplateRepository sysTableTemplateRepository) {
        this.sysTableTemplateRepository = sysTableTemplateRepository;
    }

    @Override
    public ListPager<SysTableTemplate> findSysTableTemplateByPage(SysTableTemplate sysTableTemplate, Pager pager) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(sysTableTemplate.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(sysTableTemplate.getSoftType(), "softType", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getPage(), "page", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getTemplateType(), "templateType", ddlPackBean);
        pager = PagerHelper.getPager(pager, sysTableTemplateRepository.findByHqlWhereCount(ddlPackBean));
        return new ListPager(sysTableTemplateRepository.findByHqlWherePage(ddlPackBean, pager), pager);
    }

    @Override
    public List<SysTableTemplate> findSysTableTemplate(SysTableTemplate sysTableTemplate) {
        DdlPackBean result = DdlPackBean.getDdlPackBean(sysTableTemplate.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(sysTableTemplate.getSoftType(), "softType", result);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getPage(), "page", result);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getTemplateType(), "templateType", result);
        DdlPreparedPack.getNumEqualPack(sysTableTemplate.getId(), "id", result);
        return sysTableTemplateRepository.findByHqlWhere(result);
    }

    @Override
    public SysTableTemplate getSysTableTemplateById(Long sysTableTemplateId) {
        return sysTableTemplateRepository.getById(sysTableTemplateId);
    }


    @Override
    public Boolean saveSysTableTemplate(SysTableTemplate sysTableTemplate) {
        return null;
    }

    @Override
    public SysTableTemplate insertSysTableTemplate(SysTableTemplate sysTableTemplate) {
        return sysTableTemplateRepository.insert(sysTableTemplate);
    }

    @Override
    public Boolean updateSysTableTemplate(SysTableTemplate sysTableTemplate) {
        sysTableTemplateRepository.update(sysTableTemplate);
        return true;
    }

    @Override
    public Boolean isExistSysTableTemplateById(Long id) {
        DdlPackBean ddlPack = DdlPackBean.getDdlPackBean(AuthUtil.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(id, "id", ddlPack);
        return sysTableTemplateRepository.isExitByHql(ddlPack);
    }

    @Override
    public int deleteSysTableTemplateByIds(Long[] ids) {
        return sysTableTemplateRepository.deleteByIds(ids);
    }

    @Override
    public Boolean isExistSysTableTemplate(SysTableTemplate sysTableTemplate) {
        DdlPackBean ddlPack = DdlPackBean.getDdlPackBean(sysTableTemplate.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(sysTableTemplate.getSoftType(), "softType", ddlPack);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getPage(), "page", ddlPack);
        DdlPreparedPack.getStringEqualPack(sysTableTemplate.getTemplateType(), "templateType", ddlPack);
        return sysTableTemplateRepository.isExitByHql(ddlPack);
    }

}
