package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysUserCustomizeConfigService;
import cn.estsh.i3plus.pojo.platform.bean.SysUserCustomizeConfig;
import cn.estsh.i3plus.pojo.platform.sqlpack.CoreHqlPack;
import cn.estsh.impp.framework.base.service.CrudService;
import org.springframework.stereotype.Service;

/**
 * @Description : 用户定制化配置服务
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2020-08-10 15:36
 * @Modify:
 **/
@Service
public class SysUserCustomizeConfigService extends CrudService<SysUserCustomizeConfig> implements ISysUserCustomizeConfigService {
    /**
     * 校验客户定制化配置是否唯一
     *
     * @param sysUserCustomizeConfig
     * @return
     */
    @Override
    public boolean checkSysUserCustomizeConfigOnly(SysUserCustomizeConfig sysUserCustomizeConfig) {
        return !getRepository().isExitByHql(CoreHqlPack.packHqlSysUserCustomizeConfigOnly(sysUserCustomizeConfig));
    }

    /**
     * 按条件查询指定的用户定制化配置
     *
     * @param sysUserCustomizeConfig
     * @return
     */
    @Override
    public SysUserCustomizeConfig getSysUserCustomizeConfigByCondition(SysUserCustomizeConfig sysUserCustomizeConfig) {
        return getRepository().getByProperty(CoreHqlPack.packHqlSysUserCustomizeConfigOnly(sysUserCustomizeConfig));
    }
}
