package cn.estsh.i3plus.core.apiservice.util;

import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.platform.plugin.elasticsearch.ElasticSearchPack;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogConsole;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogException;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogSystem;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogTaskTime;
import org.apache.commons.lang3.StringUtils;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-3-10 下午4:12
 * @Modify:
 **/
public class NoSqlPack {
    /**
     * Es 查询构建基类
     * @param bean
     * @return
     */
    public static ElasticSearchPack packElasticSearchPack(BaseBean bean){
        ElasticSearchPack result = null;
        if(StringUtils.isNotBlank(bean.getCreateDateTimeStart())){
            result = ElasticSearchPack.imppBuild(TimeTool.parseDate(bean.getCreateDateTimeStart()),bean.getClass());
        }else{
            result = ElasticSearchPack.imppBuild(bean.getClass());
        }

        if(StringUtils.isNotBlank(bean.getOrderByParam())){
            if(CommonEnumUtil.ASC_OR_DESC.ASC.getValue() == bean.getAscOrDesc()){
                result.asc(bean.getOrderByParam());
            }else {
                result.desc(bean.getOrderByParam());
            }
        }else{
            result.orderKeywordDesc("createDatetime");
        }
        return result;
    }

    public static ElasticSearchPack packEsSysLogException(SysLogException bean) {
        ElasticSearchPack result = packElasticSearchPack(bean);

        result.andNumberEquals("softType",bean.getSoftType());
        result.andStringLike("excMessage",bean.getExcMessage());
        result.andStringLike("excClassName",bean.getExcClassName());
//        result.andTextEquals("excStack",bean.getExcStack());
        result.andText("excStack",bean.getExcStack());
        result.andKeywordDateTimeBetween("createDatetime",bean.getCreateDateTimeStart(),bean.getCreateDateTimeEnd());

        return result;
    }

    public static ElasticSearchPack packEsSysLogOperate(SysLogOperate bean) {
        ElasticSearchPack result = packElasticSearchPack(bean);

        result.andKeywordEquals("id",bean.getId());
        result.andKeywordEquals("operateType",bean.getOperateType());
        result.andNumberEquals("softType",bean.getSoftType());
        result.andStringEquals("remoteIp",bean.getRemoteIp());
//        result.andStringEquals("requestUrl",bean.getRequestUrl());
        result.andTextLike("requestUrl",bean.getRequestUrl());
        result.andStringLike("userLoginName",bean.getUserLoginName());
        result.andStringEquals("createUser",bean.getCreateUser());
        result.andStringLike("operateMessage",bean.getOperateMessage());
        result.andStringDateTimeBetween("createDatetime",bean.getCreateDateTimeStart(),bean.getCreateDateTimeEnd());

        return result;
    }

    public static ElasticSearchPack packEsSysLogSystem(SysLogSystem bean) {
        ElasticSearchPack result = packElasticSearchPack(bean);

        result.andTextEquals("id",bean.getId());
        result.andTextEquals("logLevel",bean.getLogLevel());
        result.andNumberEquals("softType",bean.getSoftType());
        result.andStringEquals("remoteIp",bean.getRemoteIp());
        result.andStringEquals("logClass",bean.getLogClass());
        result.andStringEquals("logMethod",bean.getLogMethod());
        result.andTextLike("requestUrl",bean.getRequestUrl());
        result.andKeywordDateTimeBetween("createDatetime",bean.getCreateDateTimeStart(),bean.getCreateDateTimeEnd());

        return result;
    }

    public static ElasticSearchPack packEsSysLogTaskTime(SysLogTaskTime bean) {
        ElasticSearchPack result = packElasticSearchPack(bean);

        result.andKeywordEquals("id",bean.getId());
        result.andStringLike("name",bean.getName());
        result.andStringLike("groupName",bean.getGroupName());
        result.andStringEquals("schedulerServerIp",bean.getSchedulerServerIp());
        result.andKeywordDateTimeBetween("createDatetime",bean.getCreateDateTimeStart(),bean.getCreateDateTimeEnd());

        return result;
    }

    public static ElasticSearchPack packEsSysLogConsole(SysLogConsole bean) {
        ElasticSearchPack result = packElasticSearchPack(bean);

        result.andNumberBigger("id",bean.getId());
        result.andNumberEquals("softType",bean.getSoftType());
        result.andNumberEquals("requestId",bean.getRequestId());
        result.andStringLeftLike("logHost",bean.getLogHost());
        result.andStringLike("userLoginName",bean.getUserLoginName());
        result.andStringEquals("logGroup",bean.getLogGroup());
        result.andStringEquals("logLevel",bean.getLogLevel());
        result.andStringLeftLike("executeClassName",bean.getExecuteClassName());
        result.andStringLike("executeMethod",bean.getExecuteMethod());
        result.andStringLike("executeArgs",bean.getExecuteArgs());
        result.andStringLike("executeTitle",bean.getExecuteTitle());
        result.andStringLike("executeMessage",bean.getExecuteMessage());
        result.andStringLike("errorStackTrace",bean.getErrorStackTrace());
//        result.andNumberBetween("executeTime",bean.getErrorStackTrace());
        result.andKeywordDateTimeBetween("createDatetime",bean.getCreateDateTimeStart(),bean.getCreateDateTimeEnd());

        return result;
    }

}
